
let serial;
let latestData = "waiting for data";

function setup() {
    createCanvas(windowWidth, windowHeight);
    
    serial = new p5.SerialPort();

    serial.list();
    serial.open('/dev/tty.usbserial-D30A3T7Y'); // serial port

    serial.on('connected', serverConnected);

    serial.on('list', gotList);

    serial.on('data', gotData);

    serial.on('error', gotError);

    serial.on('open', gotOpen);

    serial.on('close', gotClose);
}

function serverConnected() {
    print("Connected to Server");
}

function gotList(thelist) {
    print("List of Serial Ports:");

    for (let i = 0; i < thelist.length; i++) {
        print(i + " " + thelist[i]);
    }
}

function gotOpen() {
    print("Serial Port is Open");
}

function gotClose() {
    print("Serial Port is Closed");
    latestData = "Serial Port is Closed";
}

function gotError(theerror) {
    print(theerror);
}

function gotData() {
    let currentString = serial.readLine();
    trim(currentString); // delete any extra white space from the beginning and end
    if (!currentString) return;
    // split into an array
    myDataArray = currentString.split(',');
    //console.log(myDataArray);
    latestData = myDataArray;
}

function draw() {
    // change the background colour
    background(myDataArray[0], myDataArray[1], myDataArray[2]);
    // text
    fill(0, 0, 0);
    text(latestData, 10, 10);
}